package Conf;

#Copyright (C) 2004 Susan J. Dridi sdridi@greens.org
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use strict;
use warnings;

sub org {
my $org = "Green Party of California / Partido Verde de California";	#The name of your organization
return $org;
}

sub acronym {
my $acronym = "GPCA SGA";	#Your organization's acronym
return $acronym;
}

sub group {
# the decision making body, e.g. a committee name
my $group = "GPCA Standing General Assembly / Asamblea General Parada";
return $group;
}

sub repunit {
# jgw120710: This sub forces the entire system to be limited to just one of 
# the original three choices: States, Counties, and Local Chapters.
# Might be better to have these values in a new vote db table instead, such 
# that the values can be tweaked (added, edited, deleted) from that table
# and used more flexibly in modified vote code that uses 1+ of the repunits!
my $repunit = "Counties"; #The units represented: States, Counties, Local Chapters for example
return $repunit;
}

sub defaultstateabbr {
# jgw120624: added comments...
# sub is invoked now in vote code. Intent is to make California the default
# state especially when 0+ states exist in the state table in original vote db
my $defaultstateabbr = "CA"; 
return $defaultstateabbr;
}

sub defaultcountyabbr {
# jgw120624: added this clone of defaultstateabbr.
# sub will be invoked when 0+ counties exist in the counties table I created 2
# weeks earlier and when the counties table is used by the vote code.
my $defaultcountyabbr = "SF"; 
return $defaultcountyabbr;
}

# jgw120701: relative path is relative to the scripts directory 
#   (<server-filesystem-path>/cgi-bin/vote)
# on your web host shown in oldresultspage and delinfo sub's below

sub logo {
#my $logo = "../../vote/logo.gif";	#relative path from your script to your logo image file
my $logo = "../../gpca_vote/images/greenleaf.gif";
return $logo;
}

sub progressbar {
# my $progressbar = "../../vote/green.gif";	#relative path from your script to your progressbar image file
my $progressbar = "../../gpca_vote/images/green.gif"; 
return $progressbar;
}

sub url {
my $url = "http://cagreens.org";		#Your organization's home page
return $url;
}

sub scripturl {
my $scripturl = "http://www.weblearningtools.org/cgi-bin/vote";	#The base URL for the scripts. No trailing slash or it will return invalid links!
return $scripturl;
}

sub oldresultspage {
my $oldresultspage = "http://www.weblearningtools.org/gpca_vote/OldVotingResults.html";	#The URL to the page where your old vote results are kept.
return $oldresultspage;
}

sub delinfo {
my $delinfo = "http://www.weblearningtools.org/gpca_vote/NewDelegateVoterInfo.html";	#The URL to the page where information for your delegates, representatives or voters (and observers?) about how to get a login userid
return $delinfo;
}

sub cookiename {
my $cookiename = "gpca_vote";	#The cookie name you want to use for this program
return $cookiename;
}

sub admin {
my $admin = "jenni.woodward\@cagreenideas.org";		#The admin's email address - the @ must be escaped with a \ or an error will occur
return $admin;
}

sub listserv {
my $listserv = "gpca_personnel\@cagreens.org";	#Listserv where the program may send info. The @ must be escaped with a \ or an error will occur
return $listserv;
}

sub voteendtime {
my $voteendtime = "Midnight Pacific Time";	#Or some other time zone, spelled out.
return $voteendtime;
}

1; #return true


