#!/usr/bin/perl

#JGW120714: this edited clone of Susan's create.pl script is supposed to 
# (1) make a copy of the scripts and modules from their install directories.
# (2) search them for the Conf::xxxx strings which setup.pl used to edit those 
#     scripts at install -> run setup.pl time, changing <SCRIPT_PATH> back to LIB
#     and <SCRIPT_PATH/temp> path back to TEMP in those scripts+modules where those
#     strings exist.
# (3) In this way the copied scripts & modules constitute a new distribution suitable
#     for porting to another site w/ or w/o the backed-up database from the working 
#     vote system source site.
#
#Copyright (C) 2005 Susan J. Dridi sdridi@greens.org
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


#This script will:

#0. Setup and Confirm all is OK to run
# a. Get the LIB and TEMP paths from the existing Conf.pm subroutines of an installed vote system.
# b. xxxxxx
#
#1. Change paths back (reverse the setup script's install-time edits)
# a. Change back the path to your library directory to LIB in all of the scripts on the line that originally read: use lib qw(LIB);
# b. Change back the path to your temp directory to TEMP in all of the scripts on the line that originally read: my $temp = qw(TEMP);
# c. Change back the path to your ballots directory to BALLOTS ??? on/near line 272 of certifyirv.
# d. Change back the path to your library directory to LIBin the Email.pm, HeadFoot.pm, DataCheck.pm, CgiErrors.pm, voteend, and phases files.
# e. Change back the path to your temp directory to TEMP in the phases file, on/near line 143.
# f. Change back the path to your email program to XXXX ??? in the Email.pm file.
# g. Change back the path to your library directory to LIB in create.pl
# h. Change back the path to your ballots directory to BALLOTS ??? on/near lines 152 and 153 of ChoiceCounter.pm.

#2. Edit the create.pl and DBConnect.pm files

use strict;
use warnings;
use Fcntl;
use Tie::File;

my ($lib, $newlib, $temp, $newtemp, $ballot, $newballot, $email, $newemail, $dirloc, $newdirloc, $scriptsdir, $newscriptsdir, $middle, $newmiddle, $db, $newdb, $dba, $newdba, $dbap, $newedbap, $dbw, $newdbw, $dbwp, $newdbwp, $dbr, $newdbr, $dbrp, $newdbrp, $almost, $fname, $lname, $addy, $login, $password, $finish);

start();

sub start {

print "\n\nFirst we GET the current path information.\n\n";

print "Confirm the following is the full path for the modules directory (NOT including a trailing slash):";
#$lib = <STDIN>;

print "Confirm the following is the full path for the temp directory for this program (NOT including a trailing slash):";
#$temp = <STDIN>;

print "Confirm the following is the full path for the ballots directory (NOT including a trailing slash):";
#$ballot = <STDIN>;

print "Confirm the following is the full path to your current web host's email program (NOT including a trailing slash):";
$email = <STDIN>;

print "Have you moved the files to their appropriate directories (m) or are they still in the original directories (o)? (m/o)\n";
$dirloc = <STDIN>;
chomp ($dirloc);

if ($dirloc eq "m")
	{
	print "What is the full path to your new scripts directory?\n";
	$newscriptsdir = <STDIN>;
	}
	
print "\nPath Info:\n\n";
print "Modules Directory: $lib";
print "Program Temp Directory: $temp";
print "Program Ballots Directory: $ballot";
print "Email Program Path: $email";

if ($dirloc eq "m")
	{
	print "Files are in their new location.\n";
	print "Your scripts are located at $scriptsdir";
	}
elsif ($dirloc eq "o")
	{print "Files are in their original location.\n";}
else
	{
	print "Have you moved the files to their appropriate directories (m) or are they still in their original directories (o)? (m/o)\n";
	$dirloc = <STDIN>;
	}

print "\nIs this correct? (if not, type q to quit) - (y/n/q):";
chomp ($middle = <STDIN>);
if ($middle eq "y")
	{middle();}
elsif ($middle eq "q")
	{exit();}
else
	{start();}

}

sub middle {

print "\n\nConfirm the vote system's information about your database.\n\n";

print "Confirm the following is the name of your vote system's database:";
$db = <STDIN>;

print "Confirm the following is the DB user name with CREATE and DROP TABLE privileges:";
$dba = <STDIN>;

print "Enter the password:";
$dbap = <STDIN>;

print "Enter the DB user name with INSERT, UPDATE, DELETE and SELECT privileges:";
$dbw = <STDIN>;

print "Enter the password:";
$dbwp = <STDIN>;

print "Enter the DB user name with SELECT privileges:";
$dbr = <STDIN>;

print "Enter the password:";
$dbrp = <STDIN>;

print "\nDatabase Info:\n\n";
print "Database Name: $db";
print "Powerful User: $dba";
print "Password: $dbap";
print "Write User: $dbw";
print "Password: $dbwp";
print "Read User: $dbr";
print "Password: $dbrp";

print "\nIs this correct? (type q to quit) - (y/n/q):";
chomp ($almost = <STDIN>);
if ($almost eq "y")
	{almost();}
elsif ($almost eq "q")
	{exit();}
else
	{middle();}
}

sub almost {

print "\n\nFinally, we need to create an initial user with admin privileges for the program.\n\n";

print "First Name:";
$fname = <STDIN>;

print "Last Name:";
$lname = <STDIN>;

print "Email Address:";
$addy = <STDIN>;

print "Login Name (no spaces!):";
$login = <STDIN>;

print "Password (no spaces!):";
$password = <STDIN>;

print "\nInitial Program User Info:\n\n";
print "First Name: $fname";
print "Last Name: $lname";
print "Email Address: $addy";
print "Login: $login";
print "Password: $password";

print "\nIs this correct? (type q to quit) - (y/n/q):";
chomp ($finish = <STDIN>);
if ($finish eq "y")
	{finish();}
elsif ($finish eq "q")
	{exit();}
else
	{almost();}
}


sub finish {

#Replace the path info in the scripts and modules:

chomp ($lib);
chomp ($temp);
chomp ($ballot);
chomp ($email);
chomp ($dirloc);
if ($scriptsdir)
	{chomp ($scriptsdir);}

#Remove any trailing slashes from the directories:

chomp ($db);
chomp ($dba);
chomp ($dbap);
chomp ($dbw);
chomp ($dbwp);
chomp ($dbr);
chomp ($dbrp);

chomp ($fname);
chomp ($lname);
chomp ($addy);
chomp ($login);
chomp ($password);

my $file;

#Reverse Edit the copy of the create.pl file:
my @create;
tie @create, 'Tie::File', "create.pl" or die $!;
# the following string replace statements are reversed to un-edit the create.pl copy
for (@create) {
	s+$lib+LIB+g;
	s+$db+DBNAME+g;
	s+$dba+DBUSER+g;
	s+$dbap+DBPW+g;
	s+$fname+FNAME+g;
	s+$lname+LNAME+g;
	s+$addy+ADDY+g;
	s+$login+LOGIN+g;
	s+$password+PASSWORD+g;
	}

#Edit the use lib qw(LIB) line in the copy of the following files:  
#  NOT FULLY REVISED YET jgw120714
if ($dirloc eq "o")
	{
	my $libdir = qw(../lib);
	chdir($libdir) or die $!;
	}
else
	{chdir($lib) or die $!;}

my @libfiles = qw(voteend phases HeadFoot.pm Email.pm DataCheck.pm crontab.txt CgiErrors.pm);

foreach $file(@libfiles)
	{
	my @lib;
	tie @lib, 'Tie::File', $file or die $!;
	for (@lib) {
		s+$lib+LIB+g;
		}
	}

#UN Edit the $temp = ""; lines in the copy of the phases file:
my @phases;
tie @phases, 'Tie::File', "phases" or die $!;
for (@phases) {
	s+$temp+TEMP+g;
	}

#Edit the Email program line in the copy of the Email.pm file:
my @emails;
tie @emails, 'Tie::File', "Email.pm" or die $!;
for (@emails) {
	s+$email+MAILPROG+g;
	}

#Edit the ballots path line in the copy of the ChoiceCounter.pm file:
my @ballots1;
tie @ballots1, 'Tie::File', "ChoiceCounter.pm" or die $!;
for (@ballots1) {
	s+$ballot+BALLOTS+g;
	}

#Reverse / un-edit the database info in the copy of DBConnect:
my @dbfile;
tie @dbfile, 'Tie::File', "DBConnect.pm" or die $!;
for (@dbfile) {
	s+$db+DBNAME+g;
	s+$dbw+DBW+g;
	s+$dbwp+DBPW+g;
	s+$dbr+DBR+g;
	s+$dbrp+DBPR+g;
	}


$newscriptsdir = qw(../scripts) unless $newscriptsdir;

chdir($newscriptsdir) or die $!;

my @scripts = qw(admin admindel admindelegates admindistricts admindist admincommittees admincom adminirv adminprop certifyirv contacts delegates index login logout irvdetail irvresult propdetail propresult viewballot vote voteresults votinghistory);

foreach $file(@scripts)
	{
	my @script;
	tie @script, 'Tie::File', $file or die $!;
	for (@script) {
		s+$lib+LIB+g;
		s+$temp+TEMP+g;
		}
	}

#UN Edit the ballots path line in the copy of the certifyirv file:
my @ballots2;
tie @ballots2, 'Tie::File', "certifyirv" or die $!;
for (@ballots2) {
	s+$ballot+BALLOTS+g;
	}


print "\n\nNow just un-edit the Conf.pm file.\n";
print "Conf.pm contains examples of the organization specific items to edit.\n";
print "Then run create.pl and you should be up and running!\n\n";
# HOW TO DO THAT AUTO-MAGICALLY ??? jgw120714
exit();
}
